<template>
  <div>
    <v-card>
      <v-toolbar color="grey" dark>
        <v-toolbar-title class="white--text">
          LISTA DE SEMAFOROS
          <v-tooltip bottom>
            <template v-slot:activator="{ on, attrs }">
              <v-btn
                fab
                class="white--text"
                color="primary"
                bottom
                right
                v-bind="attrs"
                v-on="on"
                absolute
                :to="{
                  name: 'sistema_informacion_dashboard_v2_semaforos_nuevo',
                }"
              >
                <v-icon>mdi-plus</v-icon>
              </v-btn>
            </template>
            <span>Nuevo semaforo</span>
          </v-tooltip>
        </v-toolbar-title>
        <v-spacer></v-spacer>
        <v-text-field
          v-model="search"
          label="Buscar"
          flat
          class="mr-16"
          dark
          solo-inverted
          append-icon="mdi-magnify"
          hide-details
          clear-icon="mdi-close-circle-outline"
        ></v-text-field>
      </v-toolbar>
      <v-list three-line subheader>
        <v-subheader>
          <v-badge
            color="grey"
            dark
            inline
            :value="searchResult.length"
            :content="searchResult.length"
          >
            <span class="pt-2">SEMAFOROS</span>
          </v-badge>
        </v-subheader>
        <v-list-item-group
          v-model="selectedItem"
          style="overflow: auto;max-height:500px; min-height:500px"
          color="primary"
        >
          <v-divider />
          <template v-for="(item, indexItem) in searchResult">
            <v-list-item :key="indexItem" link>
              <v-list-item-avatar>
                <v-icon color="grey lighten-1" x-large
                  >mdi-traffic-light</v-icon
                >
              </v-list-item-avatar>
              <v-list-item-content>
                <v-list-item-title>
                  <router-link
                    class="text-decoration-underline"
                    :to="toEditSemaforo(item)"
                  >
                    {{ item.descripcion }}
                  </router-link>
                </v-list-item-title>
                <v-list-item-subtitle>
                  <v-badge
                    color="primary"
                    inline
                    overlap
                    :value="item.totalRangos"
                    :content="item.totalRangos"
                  >
                    <v-icon color="grey lighten-1">
                      mdi-arrange-bring-to-front
                    </v-icon>
                    <router-link
                      class="text-decoration-underline"
                      :to="toSemaforoRangos(item)"
                    >
                      Rangos
                    </router-link>
                  </v-badge>
                </v-list-item-subtitle>
              </v-list-item-content>
              <v-list-item-action>
                <v-tooltip bottom>
                  <template v-slot:activator="{ on, attrs }">
                    <v-btn
                      class="white--text"
                      v-bind="attrs"
                      v-on="on"
                      fab
                      small
                      color="primary"
                      @click="deleteItemSemaforo(indexItem, item)"
                    >
                      <v-icon>mdi-delete</v-icon>
                    </v-btn>
                  </template>
                  <span>Borrar semaforo</span>
                </v-tooltip>
              </v-list-item-action>
            </v-list-item>
            <v-divider :key="'divider-' + indexItem" />
          </template>
        </v-list-item-group>
      </v-list>
    </v-card>
    <template>
      <v-dialog v-model="isDialogDeleteSemaforo" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <strong>¡Oh oh...! </strong>
            Borrar semaforo. Estas totalmente seguro?
            <v-icon right color="orange">mdi-alert</v-icon>
          </v-card-title>
          <v-divider />
          <v-card-text class="pt-2">
            <p v-if="editedItemSemaforo.descripcion">
              Para confirmar esta acción por favor escribe:
              <br />
              <em
                ><code>{{ editedItemSemaforo.descripcion }}</code></em
              >
            </p>
            <v-text-field
              v-model="confirmTextSemaforo"
              :autofocus="true"
              label="Confirma con el descripcion del semaforo"
              flat
              class="mr-2 ml-2"
            />
          </v-card-text>
          <v-divider />
          <v-card-actions>
            <div style="width:100%" class="btnCenter">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="secondary"
                @click="closeDeleteSemaforo"
                >No, cancelar</v-btn
              >
              <v-btn
                :class="[
                  {
                    desac: !(
                      editedItemSemaforo.descripcion &&
                      confirmTextSemaforo == editedItemSemaforo.descripcion
                    ),
                  },
                ]"
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="deleteSemaforo"
                >Si, continuar</v-btn
              >
            </div>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </template>
  </div>
</template>
<script>
import store from "@/store";
const serviceCommons = store.state.serviceCommons;
const axios = store.state.axiosApiLocal;
export default {
  name: "Component-ListaSemaforos",
  data: (vm) => ({
    isDialogDeleteSemaforo: false,
    data: [],
    loading: false,
    caseSensitive: false,
    search: null,
    selectedItem: null,
    editedItemSemaforo: {
      descripcion: null,
    },
    defaultEditedItemSemaforo: {
      descripcion: null,
    },
    indexItemSemaforo: null,
    confirmTextSemaforo: null,
  }),
  watch: {
    isDialogDeleteSemaforo(val) {
      if (!val) {
        this.closeDeleteSemaforo();
      }
    },
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    },
    searchResult() {
      let tempData = this.data;
      if (this.search != "" && this.search) {
        tempData = tempData.filter((item) => {
          return item.descripcion
            .toUpperCase()
            .includes(this.search.toUpperCase());
        });
      }
      if (tempData.length > 0) {
        tempData = tempData.sort((a, b) => {
          let fa = a.descripcion.toLowerCase();
          let fb = b.descripcion.toLowerCase();
          if (fa < fb) {
            return -1;
          }
          if (fa > fb) {
            return 1;
          }
          return 0;
        });
      }
      return tempData;
    },
  },
  methods: {
    toEditSemaforo(semaforo) {
      return {
        name: "sistema_informacion_dashboard_v2_semaforos_edicion",
        params: {
          semaforo: this.serviceCommons.objectToBase64(semaforo),
        },
      };
    },
    toSemaforoRangos(semaforo) {
      return {
        name: "sistema_informacion_dashboard_v2_semaforos_edicion",
        params: {
          semaforo: this.serviceCommons.objectToBase64(semaforo),
        },
        query: {
          rangos: this.serviceCommons.objectToBase64({}),
        },
      };
    },
    deleteSemaforo() {
      let semaforo = this.editedItemSemaforo;
      let indexItem = this.indexItemSemaforo;
      axios
        .delete(
          "/sistema-informacion/tablero/semaforos/v1/" + semaforo.idSemaforo
        )
        .then((response) => {
          this.data.splice(indexItem, 1);
          this.closeDeleteSemaforo();
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
    deleteItemSemaforo(indexItem, item) {
      this.editedItemSemaforo = item;
      this.indexItemSemaforo = indexItem;
      this.isDialogDeleteSemaforo = true;
    },
    closeDeleteSemaforo() {
      this.isDialogDeleteSemaforo = false;
      this.$nextTick(() => {
        this.editedItemSemaforo = Object.assign(
          {},
          this.defaultEditedItemSemaforo
        );
        this.indexItemSemaforo = -1;
        this.confirmTextSemaforo = null;
      });
    },
    getSemaforoRangos(semaforo) {
      axios(
        "/sistema-informacion/tablero/semaforos/v1/" +
          semaforo.idSemaforo +
          "/rangos"
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            semaforo.totalRangos = data.resultado.rangos.length;
          }
        })
        .catch((error) => {});
    },
    getSemaforos() {
      this.loading = true;
      axios("/sistema-informacion/tablero/semaforos/v1/")
        .then((response) => {
          let data = response.data;
          if (data) {
            data.resultado.semaforos = data.resultado.semaforos.map(
              (semaforo) => {
                semaforo.totalRangos = null;
                return semaforo;
              }
            );
            this.data = data.resultado.semaforos;
          }
        })
        .catch((error) => {
          if (error.response && error.response.status == 404) {
            this.data = [];
          } else {
            console.log(error);
          }
        })
        .finally(() => {
          this.loading = false;
          this.data.forEach((semaforo) => {
            this.getSemaforoRangos(semaforo);
          });
        });
    },
  },
  created() {
    this.getSemaforos();
  },
};
</script>
